package com.sagacloud;
/*
 * Author: Jxing
 * Create Time: 2019/3/12
 */

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.io.IOException;
import java.util.Map;
import java.util.Properties;
import java.util.concurrent.ConcurrentHashMap;

public class Config {
    private static Logger log = LoggerFactory.getLogger(Config.class);
    private static Map<String, String> configMap = new ConcurrentHashMap<>();
    private static Properties prop = null;
    public static String getProperty(String key){
        if(!configMap.containsKey(key)) {
            synchronized (Config.class) {
                try {
                    if (prop == null) {
                        prop = new Properties();
                        prop.load(Config.class.getClassLoader().getResourceAsStream("config.properties"));
                    }
                    if (!configMap.containsKey(key)) {
                        configMap.put(key, prop.getProperty(key));
                    }
                } catch (IOException e) {
                    e.printStackTrace();
                    //log.error("Load properties failed.");
                }
            }
        }
        return configMap.get(key);
    }
}
